import itertools, random, copy

global tiles
tiles = list(itertools.product(['man','pin','sou'],range(1,10))) + list(itertools.product(['ton','nan','sha','pei','chun','haku','hacu'],[0]))

global code
nums = list(range(1, 10)) + list(range(21, 30)) + list(range(41, 50)) + [70,73,76,79,82,85,88]
code1 = {tiles[i-1]:nums[i-1] for i in range(0, 35)}
code2 = {nums[i-1]:tiles[i-1] for i in range(0, 35)}
code = code1.copy()
code.update(code2)

def encode(hand):
    en_hand = []
    for el in hand:
        en_hand.append(code[el])
    return(sorted(en_hand))

class node:

    def __init__(self, value, parent=None,child=[]):
        self.value = value
        self.parent = parent
        self.child=child
        self.pair = False
        self.protosets = 0
        self.sh = None

    def add(self,other):
        other.parent = self
        self.child.append(other)

def single(hand,root):
    if len(hand) < 1 or len(root.value) == 1:
        return(None)
    node1 = node((hand[0],))
    node1.sh = root.sh
    return(node1)

def head(hand,root):
    if not (root.pair):
        if len(hand) < 2:
            return(None)
        a = hand[0]
        if (a == hand[1]):
            temp = (a,a)
            node2 = node(temp)
            node2.sh = root.sh-1
            node2.pair = True
            return(node2)
    return(None)

def sidewait(hand,root):
    if len(hand) < 2:
            return(None)
    a = hand[0]
    if (a+1 in hand):
        node3 = node((a,a+1))
        if root.protosets > 3:
            node3.sh = root.sh
            node3.protoset = root.protosets + 1
        else:
            node3.sh = root.sh - 1
            node3.protoset = root.protosets + 1
        return(node3)
    return(None)

def kanchan(hand,root):
    if len(hand) < 2:
            return(None)
    a = hand[0]
    if (a+2 in hand) and (a%10 != 9):
        node4 = node((a,a+2))
        if root.protosets > 3:
            node4.sh = root.sh
            node4.protoset = root.protosets + 1
        else:
            node4.sh = root.sh - 1
            node4.protoset = root.protosets + 1
        return(node4)
    return(None)

def pon(hand,root):
    if len(hand) < 3:
            return(None)
    a = hand[0]
    if (a == hand[1]) and (a == hand[2]):
        node5 = node((a,a,a))
        node5.sh = root.sh - 2
        return(node5)
    return(None)

def chi(hand,root):
    if len(hand) < 3:
            return(None)
    a = hand[0]
    if (a+1 in hand) and (a+2 in hand):
        node6 = node((a,a+1,a+2))
        node6.sh = root.sh - 2
        return(node6)
    return(None)

def pair(hand, root):
    if len(hand) < 2:
        return(None)
    a = hand[0]
    if (a == hand[1]) and not(root.pair):
        node7 = node((a,a))
        if root.protosets > 3:
            node7.sh = root.sh
            node7.protoset = root.protosets + 1
        else:
            node7.sh = root.sh - 1
            node7.protoset = root.protosets + 1
        return(node7)
    return(None)

def subtract(hand, root):
    nodes = [single(hand,root), head(hand,root), sidewait(hand,root), kanchan(hand,root), pair(hand,root), pon(hand,root), chi(hand,root)]
    nodes = list(filter(lambda a: a != None, nodes))
    return(nodes)

def isolated(hand):
    iso = []
    temp = hand.copy()
    for el in hand:
        if (el-1 not in hand) and (el+1 not in hand) and (el-2 not in hand) and (el+2 not in hand) and (hand.count(el) == 1):
            iso.append(el)
            temp.remove(el)
    iso = tuple(iso)
    return(iso,temp)


def shanten(hand,root,num):
    if root is None:
        temp = isolated(hand)
        roo = node(temp[0])
        hand = temp[1]
        roo.sh = num
    else:
        roo = copy.copy(root)
        #print(roo)
    d = subtract(hand,roo)
    c = []
    #print(root)
    del root
    for i in d:
        hand1 = hand.copy()
        for j in i.value:
            hand1.remove(j)
        if len(hand1) == 0:
            return(i)
        a = shanten(hand1,i,i.sh)
        i.add(a)
        #i.parent = roo
        #c.append(i)
        roo.add(i)        
    #roo.child = c
    return(roo)

##wall = {tiles[i-1]: 4 for i in range(0, 35)}
##hand = []
##L = 0
##while L != 14:
##    tile = random.choice(list(wall.keys()))
##    if wall[tile] != 0:
##        hand.append(tile)
##        wall[tile] = wall[tile]-1
##        L += 1
#hand = sorted(hand)
#a = shanten(encode(hand[:-1]))
#print(encode(hand[:-1]))
#print(a.value)
#for el in a.child:
#    print(el.value)
hand = [2, 3, 5]
a = shanten(hand,None,2)
print(hand)
print(a.value)
for el in a.child:
    print(el.value)
for i in a.child[0].child:
    print(i.value)

##i = a.child
##while i != []:
##	i = i[0].child
##	for j in i:
##		print(j.value)